#include <stdio.h>
#include <stdlib.h>
#include <netdb.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <signal.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <arpa/inet.h>

#include "main.h"
#include "readconf.h"
//--------------------------------------------------------------------------------
#define alarmTime	3
#define timeOut		60
// #define NODAEMON 
// #define LINECOM

#ifdef LINECOM
#define port 4001
#else
#define port 4000
#endif
//--------------------------------------------------------------------------------
int realPingNum;	//-     
char ping0[255];	//        
char ping1[255];	//  

int WriteLog(char *);
void ProcessData(int np, const char * data);

PINGSTAT pingstat[MAXPINGNUM];						
//--------------------------------------------------------------------------------						
int main()
{
struct protoent *proto;
int    sock,len,bit;
socklen_t msinlen;
struct sockaddr_in msin = { AF_INET};
struct hostent* h;
char   data[1024];
struct timeval tv;
long long tc;
int  number=1;
int np;
unsigned ip;
char b0,b1,b2,b3;
memset(pingstat,0,sizeof(PINGSTAT)*MAXPINGNUM);

realPingNum=ReadConf(pingstat);
//PrintPing(pingstat);

for (int i=0; i<MAXPINGNUM; i++)
	{
	gettimeofday(&tv,0);
	pingstat[i].firstPing=1;
    pingstat[i].lastTime=(long long)(tv.tv_sec*1000000+tv.tv_usec)/1000;
    pingstat[i].t=time(NULL);
	}


if ( (sock=socket(AF_INET,SOCK_DGRAM,IPPROTO_UDP)) < 0 )
	{
	fprintf(stderr,"   : %s\n", strerror(errno));
	exit(1);
	}
bzero(&msin, sizeof(msin));
msin.sin_family = AF_INET;
msin.sin_addr.s_addr = htonl(INADDR_ANY);
msin.sin_port = htons(port);

if ( bind(sock,(struct sockaddr*)&msin, sizeof(msin)) < 0)
	{
	fprintf(stderr," bind: %s\n", strerror(errno));
	exit(1);
	}
gettimeofday(&tv,0);
//printf(" UDP  %d:\n", port);

signal(SIGALRM,CatchAlarm);
alarm(alarmTime);

#ifndef NODAEMON
switch (fork())
	{
    case -1:        // 
        fprintf(stderr, " \n");
        exit(1);
        break;
	case 0:         // 
		close(0);
		close(1);
		close(2);
        setsid();
        break;
    default:        //  
		exit(0);
        break;
    }
#endif

for (;;)
	{
	msinlen = sizeof(msin);
	
	signal(SIGALRM,CatchAlarm);
	alarm(alarmTime);
	//----------------------------------------
	len = recvfrom(sock, data, sizeof(data), 0, (struct sockaddr*)&msin, &msinlen);
	//----------------------------------------
	signal(SIGALRM,SIG_IGN);
	WriteHTML();
	if ( len < 0 )
		{
		fprintf(stderr,"    : %s\n", strerror(errno));
		exit(1);
		}
	#ifdef LINECOM
	if ( len == 128)
	#else
	if ( len == 74 )
	#endif
		{
		gettimeofday(&tv,0);

		tc=(int)(tv.tv_sec*1000000+tv.tv_usec)/1000;

		#ifdef LINECOM
        memcpy(&ip,data,4);
        #else
		memcpy(&ip,&msin.sin_addr,4);
		#endif

		np=FindIP(ip);

		#ifdef LINECOM
		ProcessData(np, data+4);
        #else
		ProcessData(np, data);
        #endif
        
        if (np>=0)
			{
            pingstat[np].time[pingstat[np].timePos]=(int)(tc-pingstat[np].lastTime);

			pingstat[np].lastTime=(long long)(tv.tv_sec*1000000+tv.tv_usec)/1000;
			pingstat[np].t=time(NULL);

			pingstat[np].timePos++;
			if (pingstat[np].timePos>=50)
				{
				pingstat[np].timePos=0;
				}
			}
		}
	}
return 0;
}
//--------------------------------------------------------------------------------
int FindIP(unsigned long ip)
{
for (int i=0; i<MAXPINGNUM; i++)
	{
	if (ip==pingstat[i].IP) return i;
	}
return -1;
}
//--------------------------------------------------------------------------------
int WriteHTML()
{
int at,n;
FILE * f;
char str[50];
char timeStr[200];
int t;
char clRed[]="Red";
char clWhite[]="Red";
char clGreen[]="Lime";
char clGray[]="Gray";
char * color;

f=fopen("/var/pingstat.html","wt");
if (!f)
	{
	printf("Error!\n");
	return -1;
	}

fprintf(f,"<HTML>\n");
fprintf(f,"<HEAD>\n");
fprintf(f,"<TITLE> linecom.............Stat</TITLE>\n");
fprintf(f,"<META http-equiv=\"Content-Type\" content=\"text/html; charset=koi8-r\">\n");
fprintf(f,"<META http-equiv=\"refresh\" content=\"30,http://www.topol.dp.ua/ping.html\">\n");

fprintf(f,"</HEAD>\n");
fprintf(f,"<BODY>\n");
fprintf(f,"<TABLE WIDTH=\"100%\" BORDER=1>\n");

fprintf(f,"<TR BGCOLOR=\"White\">\n");
fprintf(f,"<TD WIDTH=\"20%\"></TD>\n");
fprintf(f,"<TD WIDTH=\"15%\">IP-</TD>\n");
fprintf(f,"<TD WIDTH=\"20%\"> </TD>\n");
fprintf(f,"<TD WIDTH=\"15%\"> <br> </TD>\n");

fprintf(f,"<TD WIDTH=\"5%\"> 0</TD>\n");
fprintf(f,"<TD WIDTH=\"5%\"> 1</TD>\n");
fprintf(f,"<TD WIDTH=\"5%\"> 2</TD>\n");
fprintf(f,"<TD WIDTH=\"5%\"> 3</TD>\n");
fprintf(f,"<TD WIDTH=\"5%\"> 4</TD>\n");
fprintf(f,"<TD WIDTH=\"5%\"> 5</TD>\n");
fprintf(f,"<TD WIDTH=\"5%\"> 6</TD>\n");
fprintf(f,"<TD WIDTH=\"5%\"> 7</TD>\n");

fprintf(f,"</TR>\n");

for (int j=0; j<realPingNum; j++)
	{
	n=0;
	at=0;
	for (int i=0; i<50; i++)
		{
		at+=pingstat[j].time[i];
		if (pingstat[j].time[i]!=0)
			{
			n++;
			}
		at=at;
		}

	sprintf(str,"IP %d.%d.%d.%d ",
	(pingstat[j].IP)&0xFF,
	(pingstat[j].IP>>8)&0xFF,
	(pingstat[j].IP>>16)&0xFF,
	(pingstat[j].IP>>24)&0xFF);
	t=pingstat[j].t;
	strcpy(timeStr,ctime(&(time_t)t));

	fprintf(f," <!-- ==================================================================== -->");

	if (time(NULL)-t<timeOut/2)
		{
		fprintf(f,"<TR BGCOLOR=\"White\">\n");
		}

	if ((time(NULL)-t>=timeOut/2) && (time(NULL)-t<timeOut))
		{
		fprintf(f,"<TR BGCOLOR=\"Yellow\">\n");
		}

	if (time(NULL)-t>=timeOut)
		{
		fprintf(f,"<TR BGCOLOR=\"Red\">\n");
		}
	
	
    fprintf(f,"<TD WIDTH=\"20%\">%s</TD>\n",pingstat[j].address);
	fprintf(f,"<TD WIDTH=\"15%\">%s</TD>\n",str);
	fprintf(f,"<TD WIDTH=\"20%\">%s</TD>\n",timeStr);

	if (n==0)
		{
		fprintf(f,"<TD WIDTH=\"15%\">----</TD>\n",str);
		}
	else
		{
		fprintf(f,"<TD WIDTH=\"15%\">%d</TD>\n",at/n);
		}

	//0
	if (pingstat[j].used[0])
	    {
	    if (pingstat[j].def[0]!=((pingstat[j].byte&0x01)>>0)) color=clWhite;
	    else color=clGreen;
	    }
	else color=clGray;
	fprintf(f,"<TD BGCOLOR=\"%s\" WIDTH=\"5%\">%s</TD>\n", color, pingstat[j].descrs[0]);
	//1
	if (pingstat[j].used[1])
	    {
	    if (pingstat[j].def[1]!=((pingstat[j].byte&0x02)>>1)) color=clWhite;
	    else color=clGreen;
	    }
	else color=clGray;
	fprintf(f,"<TD BGCOLOR=\"%s\" WIDTH=\"5%\">%s</TD>\n", color, pingstat[j].descrs[1]);
	//2
	if (pingstat[j].used[2])
	    {
	    if (pingstat[j].def[2]!=((pingstat[j].byte&0x04)>>2)) color=clWhite;
	    else color=clGreen;
	    }
	else color=clGray;
	fprintf(f,"<TD BGCOLOR=\"%s\" WIDTH=\"5%\">%s</TD>\n", color, pingstat[j].descrs[2]);
	//3
	if (pingstat[j].used[3])
	    {
	    if (pingstat[j].def[3]!=((pingstat[j].byte&0x08)>>3)) color=clWhite;
	    else color=clGreen;
	    }
	else color=clGray;
	fprintf(f,"<TD BGCOLOR=\"%s\" WIDTH=\"5%\">%s</TD>\n", color, pingstat[j].descrs[3]);
	//4
	if (pingstat[j].used[4])
	    {
	    if (pingstat[j].def[4]!=((pingstat[j].byte&0x10)>>4)) color=clWhite;
	    else color=clGreen;
	    }
	else color=clGray;
	fprintf(f,"<TD BGCOLOR=\"%s\" WIDTH=\"5%\">%s</TD>\n", color, pingstat[j].descrs[4]);
	//5
	if (pingstat[j].used[5])
	    {
	    if (pingstat[j].def[5]!=((pingstat[j].byte&0x20)>>5)) color=clWhite;
	    else color=clGreen;
	    }
	else color=clGray;
	fprintf(f,"<TD BGCOLOR=\"%s\" WIDTH=\"5%\">%s</TD>\n", color, pingstat[j].descrs[5]);
	//6
	if (pingstat[j].used[6])
	    {
	    if (pingstat[j].def[6]!=((pingstat[j].byte&0x40)>>6)) color=clWhite;
	    else color=clGreen;
	    }
	else color=clGray;
	fprintf(f,"<TD BGCOLOR=\"%s\" WIDTH=\"5%\">%s</TD>\n", color, pingstat[j].descrs[6]);
	//7
	if (pingstat[j].used[7])
	    {
	    if (pingstat[j].def[7]!=((pingstat[j].byte&0x80)>>7)) color=clWhite;
	    else color=clGreen;
	    }
	else color=clGray;
	fprintf(f,"<TD BGCOLOR=\"%s\" WIDTH=\"5%\">%s</TD>\n", color, pingstat[j].descrs[7]);
	fprintf(f,"</TR>\n");
	}

fprintf(f," <!-- ==================================================================== -->");
fprintf(f,"</TABLE>\n");

fprintf(f,"</BODY>\n");
fprintf(f,"</HTML>\n");

fclose(f);
return 0;
}
//--------------------------------------------------------------------------------
void CatchAlarm(int sig_num)
{
static int a=0;
if (a==0)
	{
	WriteHTML();
	}
a++;
if (a>5) a=0;
char str[1024];
for (int j=0; j<realPingNum; j++)
	{
	if (pingstat[j].noPing==1)
		{
		if (time(NULL)-pingstat[j].t < timeOut-1)
			{
			pingstat[j].noPing=0;
			//  
			sprintf(str, "Ping ozhil %s", pingstat[j].address);
			WriteLog(str);
			sprintf(str, "%s \"Ping ozhil %s\"", ping1, pingstat[j].address);
			system(str);
            }
		}
	else
		{
		if (time(NULL)-pingstat[j].t > timeOut)
			{
			pingstat[j].noPing=1;
			// 
			sprintf(str, "Ping umer %s", pingstat[j].address);
			WriteLog(str);
			sprintf(str, "%s \"Ping umer %s\"", ping0, pingstat[j].address);
			system(str);
			}
		}
	}

alarm(alarmTime);
}
//--------------------------------------------------------------------------------
int WriteLog(char * line)
{
FILE * f;
char timeStr[100];
int l;
time_t tm=time(NULL);

strncpy(timeStr,ctime(&tm),99);

f=fopen("/var/log/pingstat.log","at");
if (f)
	{
	fprintf(f,strtok(timeStr,"\n"));//   ,  timeStr 
	fprintf(f," - ");
	fprintf(f,line);
	fprintf(f,"\n");
	fclose(f);
	}
return 0;
}
//-----------------------------------------------------------------------------
void ProcessData(int np, const char * data)
{
char str[255];

//   ,    ,   
//       
if (pingstat[np].firstPing)	
	{
	pingstat[np].byte=*data;	
	pingstat[np].firstPing=0;
	return;
	}

if (pingstat[np].byte==*data) return;

//     
if ((pingstat[np].byte & 0x01) ^ (*data & 0x01))
	{
	//   0
	if (pingstat[np].byte & 0x01)
		{
		sprintf(str,"%s0", pingstat[np].bits[0]);
		//printf("  0 - 1\n");
        system(str);
		}
	else
		{
		sprintf(str,"%s1", pingstat[np].bits[0]);
		//printf("  0 - 0\n");
        system(str);
		}
	}
if ((pingstat[np].byte & 0x02) ^ (*data & 0x02))
	{
	//   1
	if (pingstat[np].byte & 0x02)
		{
		sprintf(str,"%s0", pingstat[np].bits[1]);
        system(str);
		}
	else
		{
		sprintf(str,"%s1", pingstat[np].bits[1]);
        system(str);
		}
	}
if ((pingstat[np].byte & 0x04) ^ (*data & 0x04))
	{
	//   2
	if (pingstat[np].byte & 0x04)
		{
		sprintf(str,"%s0", pingstat[np].bits[2]);
        system(str);
		}
	else
		{
		sprintf(str,"%s1", pingstat[np].bits[2]);
        system(str);
		}
	}
if ((pingstat[np].byte & 0x08) ^ (*data & 0x08))
	{
	//   3
	if (pingstat[np].byte & 0x08)
		{
		sprintf(str,"%s0", pingstat[np].bits[3]);
        system(str);
		}
	else
		{
		sprintf(str,"%s1", pingstat[np].bits[3]);
        system(str);
		}
	}
if ((pingstat[np].byte & 0x10) ^ (*data & 0x10))
	{
	//   4
	if (pingstat[np].byte & 0x10)
		{
		sprintf(str,"%s0", pingstat[np].bits[4]);
        system(str);
		}
	else
		{
		sprintf(str,"%s1", pingstat[np].bits[4]);
        system(str);
		}
	}
if ((pingstat[np].byte & 0x20) ^ (*data & 0x20))
	{						   
	//   5
	if (pingstat[np].byte & 0x20)
		{
		sprintf(str,"%s0", pingstat[np].bits[5]);
        system(str);
		}
	else
		{
		sprintf(str,"%s1", pingstat[np].bits[5]);
        system(str);
		}
	}
if ((pingstat[np].byte & 0x40) ^ (*data & 0x40))
	{
	//   6
	if (pingstat[np].byte & 0x40)
		{
		sprintf(str,"%s0", pingstat[np].bits[6]);
        system(str);
		}
	else
		{
		sprintf(str,"%s1", pingstat[np].bits[6]);
        system(str);
		}
	}
if ((pingstat[np].byte & 0x80) ^ (*data & 0x80))
	{
	//   7
	if (pingstat[np].byte & 0x80)
		{
		sprintf(str,"%s0", pingstat[np].bits[7]);
        system(str);
		}
	else
		{
		sprintf(str,"%s1", pingstat[np].bits[7]);
        system(str);
		}
	}
pingstat[np].byte=*data;
}
//-----------------------------------------------------------------------------
