#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "readconf.h"

extern char ping0[255];	//        
extern char ping1[255];	//  
//-------------------------------------------------------------------------------
int ReadConf(PINGSTAT * ps)
{
/*
 *Function Name:ReadConf
 *
 *Parameters: 
	       
 *
 *Description:
	     :
	
	ip=1.2.3.4
	addr=rhys_addr
	descr=bla-bla-bla
	
	bit0=aaa
	descr0=bla-bla-bla
	default0=0
	
	bit1=bbb
	descr0=bla-bla-bla
	default1=0
	
	bit2=ccc
	descr0=bla-bla-bla
	default2=1
	
	bit3=ddd
	descr0=bla-bla-bla
	default3=0
	
	bit4=eee
	descr0=bla-bla-bla
	default4=1
	
	bit5=fff
	descr0=bla-bla-bla
	default5=0
	
	bit6=ggg
	descr0=bla-bla-bla
	default6=0
	
	bit7=hhh
	descr0=bla-bla-bla
	default7=0
	
	used=11001111	
 *
 *Returns:
 *
 */

FILE * f;
int strNum=0, pingNum=-1;
char buff[1024];
char str[20];
char *s1, *s2, *s3;
int p;
//f=fopen("./pingstat.conf","rt");
f=fopen("/etc/pingstat.conf","rt");
if (f)
	{
	while (!feof(f))
		{
		memset(buff, 0, sizeof(buff));//
		fgets(buff,1000,f);
		strNum++;
		p=strspn(buff," \t");
		if (buff[p]=='#')
			{
			//
			continue;
			}
		if (buff[p]=='\n')
			{
			// 
			continue;
			}
		if (buff[p]==0)
			{
			//   \n  
			continue;
			}
		//   ,      -  
		s1=strtok(buff,"=\n");
		s2=strtok(NULL,"=\n");
		
		if (s1&&s2)
			{
			if (strcasecmp(s1,"ping0")==0)
				strncpy(ping0, s2, 254);

			if (strcasecmp(s1,"ping1")==0)
				strncpy(ping1, s2, 254);

			if (strcasecmp(s1,"ip")==0)
				{
				if (inet_addr(s2)==INADDR_NONE)
					{
					fprintf(stderr,"   %d.\n",strNum+1);
					exit(1);
					}
				pingNum++;
				memset(&ps[pingNum], 0, sizeof(PINGSTAT));
				ps[pingNum].IP=inet_addr(s2);
                continue;
				}
			if (strcasecmp(s1,"addr")==0)
				{
				if ((s3=strchr(s2, '\n'))) *s3=0;
				strncpy(ps[pingNum].address, s2, 254);
				continue;
				}
			if (strcasecmp(s1,"descr")==0)
				{
				if ((s3=strchr(s2, '\n'))) *s3=0;
				strncpy(ps[pingNum].descr, s2, 254);
				continue;
				}
			if (strcasecmp(s1,"used")==0)
				{
				char tmp[9];
				if ((s3=strchr(s2, '\n'))) *s3=0;
				strncpy(tmp, s2, 9);
				if (strlen(tmp)!=8)
					{
					printf("Error _used_\n");
					exit(1);
					}
				for (int i=0; i<=7; i++)
					{
					if (tmp[i]=='0' || tmp[i]=='1')
						{
	  					if (tmp[i]=='1')
							ps[pingNum].used[i]=1;
						if (tmp[i]=='0')
							ps[pingNum].used[i]=0;
						}
					else
						{
						printf("Error _used_\n");
						exit(1);
						}
					}
				continue;
				}
			if (strcasecmp(s1,"default")==0)
				{
				char tmp[9];
				if ((s3=strchr(s2, '\n'))) *s3=0;
				strncpy(tmp, s2, 9);
				if (strlen(tmp)!=8)
					{
					printf("Error _default_\n");
					exit(1);
					}
				for (int i=0; i<=7; i++)
					{
					if (tmp[i]=='0' || tmp[i]=='1')
						{
	  					if (tmp[i]=='1')
							ps[pingNum].def[i]=1;
						if (tmp[i]=='0')
							ps[pingNum].def[i]=0;
						}
					else
						{
						printf("Error _used_\n");
						exit(1);
						}
					}
				continue;
				}
			for (int i=0; i<=7; i++)
				{
				sprintf(str,"bit%d", i);
                if (strcasecmp(s1, str)==0)
					{
					if ((s3=strchr(s2, '\n'))) *s3=0;
					strncpy(ps[pingNum].bits[i], s2, 254);
					}
                }
			for (int i=0; i<=7; i++)
				{
				sprintf(str,"descr%d", i);
                if (strcasecmp(s1, str)==0)
					{
					if ((s3=strchr(s2, '\n'))) *s3=0;
					strncpy(ps[pingNum].descrs[i], s2, 254);
					}
				}
			}
		else
			{
			fprintf(stderr,"   %d.\n",strNum);
			exit(1);
			}
		}
	fclose(f);
	}
else
	{
	fprintf(stderr,"    .\n");
	exit(1);
	}
return pingNum+1;
}
//-------------------------------------------------------------------------------
void PrintPing(PINGSTAT * ps)
{
//         
extern int realPingNum;

for (int i=0; i<=realPingNum; i++)
	{
	printf("#########################################\n");
	printf("ip=%s\n", inet_ntoa(*((struct in_addr*)&ps[i].IP)));
	printf("address=%s\n", ps[i].address);
	printf("descr=%s\n", ps[i].descr);

	printf("bit0=%s\n", ps[i].bits[0]);
	printf("bit1=%s\n", ps[i].bits[1]);
	printf("bit2=%s\n", ps[i].bits[2]);
	printf("bit3=%s\n", ps[i].bits[3]);
	printf("bit4=%s\n", ps[i].bits[4]);
	printf("bit5=%s\n", ps[i].bits[5]);
	printf("bit6=%s\n", ps[i].bits[6]);
	printf("bit7=%s\n", ps[i].bits[7]);

	printf("descr0=%s\n", ps[i].descrs[0]);
	printf("descr1=%s\n", ps[i].descrs[1]);
	printf("descr2=%s\n", ps[i].descrs[2]);
	printf("descr3=%s\n", ps[i].descrs[3]);
	printf("descr4=%s\n", ps[i].descrs[4]);
	printf("descr5=%s\n", ps[i].descrs[5]);
	printf("descr6=%s\n", ps[i].descrs[6]);
	printf("descr7=%s\n", ps[i].descrs[7]);

	printf("def0=%d\n", ps[i].def[0]);
	printf("def1=%d\n", ps[i].def[1]);
	printf("def2=%d\n", ps[i].def[2]);
	printf("def3=%d\n", ps[i].def[3]);
	printf("def4=%d\n", ps[i].def[4]);
	printf("def5=%d\n", ps[i].def[5]);
	printf("def6=%d\n", ps[i].def[6]);
	printf("def7=%d\n", ps[i].def[7]);
	}
}
//-------------------------------------------------------------------------------
